include masm32rt.inc

.data?
	hInstance		HINSTANCE	?
.code

WND_DATA struct
	hEdit		HWND	?
	hToolTip	HWND	?
	IDT			DWORD	?
	state		DWORD	?
WND_DATA ends

main proc
LOCAL msg:MSG
LOCAL wc:WNDCLASSEX
	
	mov hInstance,rv(GetModuleHandle,0)
	mov wc.hInstance,eax
	mov wc.cbSize,SIZEOF wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,SIZEOF WND_DATA
	mov wc.lpszClassName,chr$("WinClass32")
	mov wc.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wc.hIconSm,eax
	mov wc.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	mov wc.lpszMenuName,0
	mov wc.hbrBackground,COLOR_GRAYTEXT
	invoke RegisterClassEx,ADDR wc
	mov edi,rv(CreateWindowEx,0,wc.lpszClassName,"Main Window",WS_SYSMENU or WS_SIZEBOX or WS_VISIBLE or WS_MINIMIZEBOX or WS_MAXIMIZEBOX,100,100,200,200,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,0,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg		
	.endw

	exit
	
main endp

WndProc proc uses ebx hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ti:TOOLINFO
LOCAL msg:MSG

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,0
	.elseif uMsg == WM_CREATE
		invoke SetWindowLong,hWnd,WND_DATA.hEdit,rv(CreateWindowEx,0,"EDIT",0,WS_CHILD or WS_VISIBLE,40,20,100,20,hWnd,0,hInstance,0)
    	mov ebx,rv(CreateWindowEx,0,"tooltips_class32",0, WS_POPUP or TTS_ALWAYSTIP or TTS_BALLOON,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,0,hInstance,0)
    	invoke SetWindowLong,hWnd,WND_DATA.hToolTip,ebx
    	invoke crt_memset,ADDR ti,SIZEOF ti,0
    	mov ti.cbSize,SIZEOF ti
    	mov ti.uFlags,TTF_CENTERTIP or TTF_SUBCLASS or TTF_IDISHWND
    	mov ti.hWnd,rv(GetWindowLong,hWnd,WND_DATA.hEdit)
    	m2m ti.uId,eax
    	mov ti.lpszText,chr$("Attention: CAPS LOCK ON")
		invoke SendMessage,ebx,TTM_ADDTOOL,0,ADDR ti
 		invoke SendMessage,ebx,TTM_ACTIVATE,0,0
		invoke SendMessage,ebx,TTM_SETDELAYTIME,TTDT_INITIAL,1
    	invoke SendMessage,ebx,TTM_SETDELAYTIME,TTDT_AUTOPOP,32767
    	
    	mov ebx, rv(AddAtom,"IDT_CHK_CAPSLOCK")
    	invoke SetWindowLong,hWnd,WND_DATA.IDT,ebx
    	invoke SetTimer,hWnd,ebx,25,0
    	invoke SetWindowLong,hWnd,WND_DATA.state,0
    .elseif uMsg == WM_TIMER
        .if wParam == rv(GetWindowLong,hWnd,WND_DATA.IDT)
            mov ebx,rv(GetWindowLong,hWnd,WND_DATA.state)
            mov edx,rv(GetKeyState,VK_CAPITAL)
            .if  edx & 1 && !ebx
                invoke SetWindowLong,hWnd,WND_DATA.state,1
                mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hEdit)
                .if rv(GetFocus) == ebx
                   	invoke SendMessage,rv(GetWindowLong,hWnd,WND_DATA.hToolTip),TTM_ACTIVATE,1,0
			    	mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hEdit)
                	invoke SendMessage,ebx,WM_MOUSEMOVE,0,0
                .endif
            .elseif !(edx & 1) && ebx
                invoke SetWindowLong,hWnd,WND_DATA.state,0
                mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hEdit)
                .if rv(GetFocus) == ebx
                	invoke SendMessage,rv(GetWindowLong,hWnd,WND_DATA.hToolTip),TTM_ACTIVATE,0,0
                .endif
            .endif
        .endif
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
	
WndProc endp
end main